Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/compare_timeseries_with_measures.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/compare_timeseries_with_measures.py	(revision 3916)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/compare_timeseries_with_measures.py	(revision 3917)
@@ -117,33 +117,33 @@
 
 
-expected_covariance = {'Boundary': 5.294418463841652839e-05, 
-                       'ch5': 1.169700827457795071e-04,
-                       'ch7': 1.131522443178145860e-04,
-                       'ch9': 1.251932626774203753e-04}
-
-expected_difference = {'Boundary': 8.222031767747334978e-04,
-                       'ch5': 3.390769873961110153e-03,
-                       'ch7': 2.815084054773397005e-03,
-                       'ch9': 3.208757435748204462e-03}
-
-expected_maximum_diff = {'Boundary': 2.074639250243537347e-05,
-                         'ch5': 1.443103996215826246e-03,
-                         'ch7': 8.380973795966278894e-05,
-                         'ch9': 2.081659579598611753e-03}
-
-expected_minimum_diff = {'Boundary': 2.594698240608837858e-04,
-                         'ch5': 6.360676810760659133e-04,
-                         'ch7': 4.604184345996111850e-03,
-                         'ch9': 3.428854197019200710e-03}
-
-expected_argmax_timelag = {'Boundary': 2.500000000000000000e-01,
-                           'ch5': 4.999999999999715783e-02,
-                           'ch7': 0.000000000000000000e+00,
-                           'ch9': 0.000000000000000000e+00}
-
-expected_argmin_timelag = {'Boundary': 2.500000000000000000e-01,
-                           'ch5': 7.999999999999989342e-01,
-                           'ch7': 2.050000000000000711e+00,
-                           'ch9': 1.000000000000000000e+00}
+#expected_covariance = {'Boundary': 5.294418463841652839e-05, 
+#                       'ch5': 1.169700827457795071e-04,
+#                       'ch7': 1.131522443178145860e-04,
+#                       'ch9': 1.251932626774203753e-04}
+#
+#expected_difference = {'Boundary': 8.222031767747334978e-04,
+#                       'ch5': 3.390769873961110153e-03,
+#                       'ch7': 2.815084054773397005e-03,
+#                       'ch9': 3.208757435748204462e-03}
+#
+#expected_maximum_diff = {'Boundary': 2.074639250243537347e-05,
+#                         'ch5': 1.443103996215826246e-03,
+#                         'ch7': 8.380973795966278894e-05,
+#                         'ch9': 2.081659579598611753e-03}
+#
+#expected_minimum_diff = {'Boundary': 2.594698240608837858e-04,
+#                         'ch5': 6.360676810760659133e-04,
+#                         'ch7': 4.604184345996111850e-03,
+#                         'ch9': 3.428854197019200710e-03}
+#
+#expected_argmax_timelag = {'Boundary': 2.500000000000000000e-01,
+#                           'ch5': 4.999999999999715783e-02,
+#                           'ch7': 0.000000000000000000e+00,
+#                           'ch9': 0.000000000000000000e+00}
+#
+#expected_argmin_timelag = {'Boundary': 2.500000000000000000e-01,
+#                           'ch5': 7.999999999999989342e-01,
+#                           'ch7': 2.050000000000000711e+00,
+#                           'ch9': 1.000000000000000000e+00}
 
 
@@ -262,6 +262,4 @@
     sww_filename = project.output_filename
     
-#f = file_function('okushiri_new_limiters.sww',   #The best so far
-#f = file_function('okushiri_as2005_with_mxspd=0.1.sww',
 f = file_function(sww_filename,
                   quantities='stage',
@@ -301,4 +299,7 @@
     else:
         pass
+
+    assert res-eps < expected_covariance[name] < res+eps
+    
     
 
@@ -319,4 +320,6 @@
 
 
+    assert res-eps < expected_difference[name] < res+eps
+
     # Extrema
     res = abs(max(observed_timeseries)-max(model))
@@ -333,5 +336,6 @@
     else:
         pass
-    
+
+    assert res-eps < expected_maximum_diff[name] < res+eps    
 
     
@@ -349,4 +353,6 @@
     else:
         pass
+
+    assert res-eps < expected_minimum_diff[name] < res+eps
     
 
@@ -368,4 +374,5 @@
         pass
     
+    assert res-eps < expected_argmax_timelag[name] < res+eps
 
     i0 = argmin(observed_timeseries)
@@ -384,5 +391,5 @@
         pass
 
-
+    assert res-eps < expected_argmin_timelag[name] < res+eps
 
 
Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py	(revision 3917)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py	(revision 3917)
@@ -0,0 +1,19 @@
+"""Automatic verification that the ANUGA code validates against the okushiri
+dataset as expected. See anuga_validation/okushiri_2005 for more details
+"""
+
+
+import os
+
+# FIXME: Make into unit test
+
+# FIXME: Redirect stdout and stderr
+
+s = 'create_okushiri.py'
+os.system('python %s ' %s)
+
+s = 'run_okushiri.py'
+os.system('python %s ' %s)
+
+s = 'compare_timeseries_with_measures.py'
+os.system('python %s ' %s)