Index: /anuga_core/documentation/user_manual/anuga_installation_guide.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_installation_guide.tex	(revision 3920)
+++ /anuga_core/documentation/user_manual/anuga_installation_guide.tex	(revision 3921)
@@ -52,9 +52,18 @@
 
 \begin{enumerate}  
-  \item Download and install the Enthought version of Python2.4 from \url{http://code.enthought.com/enthon/}.
-  \item Download and install Scientific Python: \url{http://sourcesup.cru.fr/frs/download.php/745/ScientificPython-2.4.9.win32-py2.4.exe}\footnote{This step will become unneccesary once Enthought sorts out netcdf support (see https://svn.enthought.com/enthought/ticket/917)}.
-  
-  %NETCDF ftp://ftp.unidata.ucar.edu/pub/netcdf/contrib/win32/netcdf-3.6.1-beta1-win32dll.zip
-  %Separate Scientific Python: http://sourcesup.cru.fr/frs/download.php/745/ScientificPython-2.4.9.win32-py2.4.exe
+ 
+  \item Install Python pre-requisites: The Enthought version of Python2.4, Scientific Python 
+  and the NetCDF library\footnote{Separate installation of Scientific Python and NetCDF 
+  will become unneccesary once Enthought sorts out netcdf support 
+  (see \url{https://svn.enthought.com/enthought/ticket/917})}. These are available from either 
+  \begin{itemize} 
+    \item The supplied ANUGA distribution as under the folder pre_requisites
+    \item The WEB:
+    \begin{itemize}  
+      \item Enthought version of Python2.4: \url{http://code.enthought.com/enthon/}.
+      \item Scientific Python: \url{http://sourcesup.cru.fr/frs/download.php/745/ScientificPython-2.4.9.win32-py2.4.exe}
+      \item NETCDF \url{ftp://ftp.unidata.ucar.edu/pub/netcdf/contrib/win32/netcdf-3.6.1-beta1-win32dll.zip}
+    \end{itemize}   
+  \end{itemize}   
   
   \item Add the following to the PATH environment variable
@@ -62,7 +71,9 @@
       PATH=C:\Python24;C:\Python24\Enthought\MingW\bin;C:\Program Files\anuga_viewer
     \end{verbatim} 
-  \item Unpack the ANUGA source code (anuga.tgz) in the python site-packages 
-  directory (C:\Python24\Lib\site-packages)
-  \item In the ANUGA root directory (C:\Python24\Lib\site-packages\anuga), run the compilation script:
+  \item Unpack the ANUGA source code (\code{anuga-1.0_xxxx.tgz}) 
+  in the python site-packages 
+  directory \code{C:\\Python24\\Lib\\site-packages}
+  \item In the ANUGA root directory (\code{C:\\Python24\\Lib\\site-packages\\anuga}), 
+  run the compilation script (either from the commandline or by clicking on it):
     {\small \begin{verbatim}
 	python compile_all.py
@@ -77,7 +88,7 @@
 To install the anuga\_viewer
 \begin{enumerate} 
-  \item Unpack the distribution () in 
+  \item Unpack the distribution (\code{anuga_viewer_1.0.tgz}) in 
     \begin{verbatim} 
-      C:\Program Files\anuga_viewer
+      C:\Program Files
     \end{verbatim}
   \item Associate .sww files with the executable
@@ -91,14 +102,27 @@
 \end{enumerate} 
 
-Try the demos provided in the ANUGA root directory (also discussed in the ANUGA user manual 
+Try the demos provided in the ANUGA root directory 
+(also discussed in the ANUGA user manual available with the distribution and also at 
 \url{http://datamining.anu.edu.au/~ole/anuga/user_manual/anuga_user_manual.pdf}) and 
 view the resulting sww files with the anuga\_viewer.
 
-
-
+To verify that the installed version of ANUGA validates satisfactorily
+against the Okushiri Island wave tank validation dataset
+(\url{http://www.cee.cornell.edu/longwave/index.cfm?page=benchmark&problem=2})
+unpack the distribution (\code{anuga_validation_1.0_xxxx.tgz}) into
+any directory and run the scripts \code{create_okushiri.py},
+\code{run_okushiri.py} and \code{compare_timeseries.py}.  See also the
+\code{README.txt} file that comes with the validation scripts for more
+details.
+
+
+
+\clearpage
 \section{Pre-requisites}
 \label{sec:prerequisites}
 
-The Anuga software core (shallow\_water, pmesh, least\_squares, ...) depends on the following:
+This and the following sections is for custom installations and installations using Linux.
+
+The ANUGA software core (shallow\_water, pmesh, least\_squares, ...) depends on the following:
 
 
@@ -156,7 +180,8 @@
 \section{Installation of source zip file}
 Get a source zip file, for example, anuga_source_3807.zip, and expand
-it in the python site-packages directory (C:\Python24\Lib\site-packages)
-
-In the ANUGA root directory (C:\Python24\Lib\site-packages\anuga), run the compilation script:
+it in the python site-packages directory (\code{C:\\Python24\\Lib\\site-packages})
+
+In the ANUGA root directory (\code{C:\\Python24\\Lib\\site-packages\\anuga}), 
+run the compilation script:
 {\small \begin{verbatim}
   python compile_all.py
Index: /anuga_core/documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 3920)
+++ /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 3921)
@@ -300,6 +300,7 @@
 significance.
 
-\verbatiminput{examples/runup.py}
-%\verbatiminput{examples/bedslope.py}
+%\verbatiminput{examples/runup.py}
+\verbatiminput{../../demos/runup.py}
+
 
 \subsection{Establishing the Mesh}\index{mesh, establishing}
Index: /anuga_core/documentation/user_manual/update_anuga_user_manual.py
===================================================================
--- /anuga_core/documentation/user_manual/update_anuga_user_manual.py	(revision 3920)
+++ /anuga_core/documentation/user_manual/update_anuga_user_manual.py	(revision 3921)
@@ -3,5 +3,13 @@
 """Update, compile and create PDF and HTML from LaTeX file
 
-This can for example be run from a cronjob:
+Usage:
+    python update_anuga_user_manual.py <options>
+    
+Options:
+    --no_html: Skip automatic generation of html version
+    
+
+
+This script can for example be run from a cronjob:
 
   crontab -e
@@ -21,29 +29,42 @@
 """
 
+from os import system, chdir
+from os.path import expanduser
 
-import os
+from sys import argv
 
 
-anugapath = os.path.expanduser('~/inundation/anuga_core/documentation/user_manual')
+anugapath = expanduser('~/inundation/anuga_core/documentation/user_manual')
 texfiles = ['anuga_user_manual', 'anuga_installation_guide']
 
-os.chdir(anugapath) # Move to location of LaTeX files 
-os.system('svn up') # Update from svn
+chdir(anugapath) # Move to location of LaTeX files 
+system('svn update') # Update from svn
 
 
+do_html = True        
+if len(argv) > 1:
+    if argv[1] == '--no_html':
+        do_html = False
+    else:
+        msg = 'Unknown option: %s' %argv[1]
+        raise Exception(msg)
+    
 for texfile in texfiles:
     print 'Processing %s' %texfile
     # Compile with LaTeX, makeindex etc
     for i in range(3):
-        os.system('latex --interaction=nonstopmode %s.tex' %texfile)
-        os.system('makeindex %s.idx' %texfile)
-        os.system('makeindex mod%s.idx' %texfile)
-        os.system('bibtex %s' %texfile)    
+        system('latex --interaction=nonstopmode %s.tex' %texfile)
+        system('makeindex %s.idx' %texfile)
+        system('makeindex mod%s.idx' %texfile)
+        system('bibtex %s' %texfile)    
 
     # Create pdf file
-    os.system('dvips %s -o %s.ps' %((texfile,)*2))    
-    os.system('ps2pdf %s.ps' %texfile)    
+    system('dvips %s -o %s.ps' %((texfile,)*2))    
+    system('ps2pdf %s.ps' %texfile)    
      
-    # Create html pages     
-    os.system('latex2html %s' %texfile)
+    # Create html pages
+    if do_html is True:
+        system('latex2html %s' %texfile)
+    else:
+        print 'Skipping html version for %s as requested' %texfile
 