Index: /anuga_core/documentation/user_manual/anuga_user_manual.tex
===================================================================
--- /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 3922)
+++ /anuga_core/documentation/user_manual/anuga_user_manual.tex	(revision 3923)
@@ -858,7 +858,7 @@
 \label{sec:realdataexample} The following discussion builds on the
 concepts introduced through the \file{runup.py} example and
-introduces a second example, \file{run\_sydney.py}.  This refers to
+introduces a second example, \file{runcairns.py}.  This refers to
 a real-life scenario, in which the domain of interest surrounds the
-Sydney region, and predominantly covers Sydney Harbour. A
+Cairns region. A
 hypothetical tsunami wave is generated by a submarine mass failure
 situated on the edge of the continental shelf.
@@ -891,7 +891,7 @@
 \subsection{The Code}
 
-Here is the code for \file{run\_sydney\_smf.py}:
-
-\verbatiminput{examples/runsydney.py}
+Here is the code for \file{runcairns.py}:
+
+\verbatiminput{../../demos/runcarins.py}
 
 In discussing the details of this example, we follow the outline
@@ -923,6 +923,6 @@
 \end{figure}
 
-Boundary tags are not restricted to \code{`left'}, \code{`right'},
-\code{`bottom'} and \code{`top'}, as in the case of
+Boundary tags are not restricted to \code{`left'}, \code{`bottom'},
+\code{`right'} and \code{`top'}, as in the case of
 \file{runup.py}. Instead the user specifies a list of
 tags appropriate to the configuration being modelled.
@@ -960,5 +960,5 @@
 \file{project.py}:
 
-\verbatiminput{examples/project.py}
+\verbatiminput{../../demos/project.py}
 
 The resulting mesh is output to a \emph{mesh file}\index{mesh
@@ -974,39 +974,52 @@
 
 {\small \begin{verbatim}
-    interior_res = 5000
-    interior_regions = [[project.northern_polygon, interior_res],
-                        [project.harbour_polygon, interior_res],
-                        [project.southern_polygon, interior_res],
-                        [project.manly_polygon, interior_res],
-                        [project.top_polygon, interior_res]]
+    islands_res = 100000
+    cairns_res = 100000
+    shallow_res = 500000
+    interior_regions = [[project.poly_cairns, cairns_res],
+                        [project.poly_island0, islands_res],
+                        [project.poly_island1, islands_res],
+                        [project.poly_island2, islands_res],
+                        [project.poly_island3, islands_res],
+                        [project.poly_shallow, shallow_res]]
 \end{verbatim}}
 
-are used to read in the specific polygons \code{project.harbour\_polygon\_2} and
-\code{botanybay\_polygon\_2} from \file{project.py} and assign a
-common resolution of to each. The statement
+are used to read in the specific polygons \code{project.cairns},
+\code{project.poly_island0},
+\code{project.poly_island1},
+\code{project.poly_island2},
+\code{project.poly_island3} and
+\code{project.poly_shallow} from \file{project.py} and assign a
+defined resolution to each. Figure \ref{fig:cairnspolys}
+illustrates the polygons used for the Cairns scenario. 
+
+\begin{figure}[hbt]
+
+  \centerline{\includegraphics[width=75mm, height=75mm]
+      {../../demos/cairns_model.jpg}}
+  \caption{Interior and bounding polygons for the \code{runcairns.py} example.}
+  \label{fig:cairnspolys}
+\end{figure}
+
+The statement
 
 {\small \begin{verbatim}
-create_mesh_from_regions(project.demopoly,
-                         boundary_tags= {'oceannorth': [0], 
-                                         'onshorenorth1': [1],
-                                         'onshorenorthwest1': [2],
-                                         'onshorenorthwest2': [3],
-                                         'onshorenorth2': [4],
-                                         'onshorewest': [5],
-                                         'onshoresouth': [6],
-                                         'oceansouth': [7],
-                                         'oceaneast': [8]},
-                         maximum_triangle_area=100000,
-                         filename=meshname,           
-                         interior_regions=interior_regions)    
+remainder_res = 10000000  
+_ = cache(create_mesh_from_regions,
+          project.polyAll,
+           {'boundary_tags': {'top': [0], 'ocean_east': [1],
+                              'bottom': [2], 'onshore': [3]},
+           'maximum_triangle_area': remainder_res,
+           'filename': meshname,
+           'interior_regions': interior_regions},
+          verbose = True, evaluate=False) 
 \end{verbatim}}
 
 is then used to create the mesh, taking the bounding polygon to be
-the polygon \code{diffpolygonall} specified in \file{project.py}.
+the polygon \code{demopoly} specified in \file{project.py}.
 The argument \code{boundary\_tags} assigns a dictionary, whose keys
 are the names of the boundary tags used for the bounding
-polygon---\code{`bottom'}, \code{`right0'}, \code{`right1'},
-\code{`right2'}, \code{`top'}, \code{`left1'}, \code{`left2'} and
-\code{`left3'}--- and whose values identify the indices of the
+polygon---\code{`top'}, \code{`ocean\_east'}, \code{`bottom'}, and
+\code{lonshore'}--- and whose values identify the indices of the
 segments associated with each of these tags. (The value associated
 with each boundary tag is a one-element list.)
@@ -1053,5 +1066,5 @@
 
 \subsection{Initial Conditions}
-Quantities for \file{runsydney.py} are set
+Quantities for \file{runcairns.py} are set
 using similar methods to those in \file{runup.py}. However,
 in this case, many of the values are read from the auxiliary file
@@ -1091,30 +1104,29 @@
 {\small \begin{verbatim}
     domain.set_quantity('elevation',
-                        filename = project.combineddemname + '.pts',
+                        filename = project.dem_name + '.pts',
                         use_cache = True,
                         verbose = True)
 \end{verbatim}}
 
-However, before this step can be executed, some preliminary steps
-are needed to prepare the file from which the data is taken. Two
-source files are used for this data---their names are specified in
-the file \file{project.py}, in the variables \code{coarsedemname}
-and \code{finedemname}. They contain `coarse' and `fine' data,
-respectively---that is, data sampled at widely spaced points over a
-large region and data sampled at closely spaced points over a
-smaller subregion. The data in these files is combined through the
-statement
-
-{\small \begin{verbatim}
-combine_rectangular_points_files(project.finedemname + '.pts',
-                                 project.coarsedemname + '.pts',
-                                 project.combineddemname + '.pts')
-\end{verbatim}}
-
-The effect of this is simply to combine the datasets by eliminating
-any coarse data associated with points inside the smaller region
-common to both datasets. The name to be assigned to the resulting
-dataset is also derived from the name stored in the variable
-\code{combinedname} in the file \file{project.py}.
+%However, before this step can be executed, some preliminary steps
+%are needed to prepare the file from which the data is taken. Two
+%source files are used for this data---their names are specified in
+%the file \file{project.py}, in the variables \code{coarsedemname}
+%and \code{finedemname}. They contain `coarse' and `fine' data,
+%respectively---that is, data sampled at widely spaced points over a
+%large region and data sampled at closely spaced points over a
+%smaller subregion. The data in these files is combined through the
+%statement
+
+%{\small \begin{verbatim}
+%combine_rectangular_points_files(project.finedemname + '.pts',
+%                                 project.coarsedemname + '.pts',
+%                                 project.combineddemname + '.pts')
+%\end{verbatim}}
+%The effect of this is simply to combine the datasets by eliminating
+%any coarse data associated with points inside the smaller region
+%common to both datasets. The name to be assigned to the resulting
+%dataset is also derived from the name stored in the variable
+%\code{combinedname} in the file \file{project.py}.
 
 \subsection{Boundary Conditions}\index{boundary conditions}
@@ -1130,13 +1142,6 @@
 {\small \begin{verbatim}
 Bd = Dirichlet_boundary([0.0,0.0,0.0])
-domain.set_boundary( {'oceannorth': Bd,
-                      'onshorenorth1': Bd,
-                      'onshorenorthwest1': Bd,
-                      'onshorenorthwest2': Bd,
-                      'onshorenorth2': Bd,
-                      'onshorewest': Bd,
-                      'onshoresouth': Bd,
-                      'oceansouth': Bd,
-                      'oceaneast': Bd} )
+domain.set_boundary( {'ocean_east': Bd, 'bottom': Bd, 'onshore': Bd,
+                          'top': Bd} )
 \end{verbatim}}
 
@@ -1145,5 +1150,5 @@
 With the basics established, the running of the `evolve' step is
 very similar to the corresponding step in \file{runup.py}. Here,
-the simulation is run for five hours (18000 seconds) with
+the simulation is run for five hours (10000 seconds) with
 the output stored every two minutes (120 seconds).
 
@@ -1151,5 +1156,5 @@
     import time t0 = time.time()
 
-    for t in domain.evolve(yieldstep = 120, duration = 18000):
+    for t in domain.evolve(yieldstep = 120, duration = 10000):
         print domain.timestepping_statistics()
         print domain.boundary_statistics(tags = 'bottom')
Index: /anuga_core/documentation/user_manual/update_anuga_user_manual.py
===================================================================
--- /anuga_core/documentation/user_manual/update_anuga_user_manual.py	(revision 3922)
+++ /anuga_core/documentation/user_manual/update_anuga_user_manual.py	(revision 3923)
@@ -54,12 +54,13 @@
     # Compile with LaTeX, makeindex etc
     for i in range(3):
-        system('latex --interaction=nonstopmode %s.tex' %texfile)
-        system('makeindex %s.idx' %texfile)
-        system('makeindex mod%s.idx' %texfile)
-        system('bibtex %s' %texfile)    
+        #os.system('latex --interaction=nonstopmode %s.tex' %texfile)
+        os.system('pdflatex --interaction=nonstopmode %s.tex' %texfile)
+        os.system('makeindex %s.idx' %texfile)
+        os.system('makeindex mod%s.idx' %texfile)
+        os.system('bibtex %s' %texfile)    
 
     # Create pdf file
-    system('dvips %s -o %s.ps' %((texfile,)*2))    
-    system('ps2pdf %s.ps' %texfile)    
+    #os.system('dvips %s -o %s.ps' %((texfile,)*2))    
+    #os.system('ps2pdf %s.ps' %texfile)    
      
     # Create html pages